const util = require('@/utils/util.js').default;
// import requestConfig from '@/static/lib/requestConfig';
export default {
	data() {
		return {
		}
	},
	mounted() {
		console.warn("---mounted---",this.pvId,this.$route.meta.keepAlive)
		if(this.pvId && !this.$route.meta.keepAlive){
			window.removeEventListener('beforeunload', this.pvCloseHandle);
			window.removeEventListener('visibilitychange', this.visibilitychange);
			window.currentPage = this;
			if(window.webglCom && window.webglCom.starRender && typeof(window.webglCom.starRender)==='function'){
				window.webglCom.starRender()
			}
			let param = {
				type: 'PV',
				pvId: this.pvId,
				locusBehaviorName: this.locusBehaviorName,
				pvCurPageName: this.pvCurPageName,
			};
			util.trackRequest(param);//发送统一PV埋点
			window.addEventListener('beforeunload', this.pvCloseHandle);
			window.addEventListener('visibilitychange', this.visibilitychange);
		}
		if(this.$route.name=="webgl_rxdz" || this.$route.name=="webgl_rxdz_roam" || this.$route.name=="webgl_rxdz_look"
		 || this.$route.name=="webgl_rxdz_test" || this.$route.name=="webgl_rxdz_test_roam" || this.$route.name=="webgl_rxdz_test_look"){//去往其他页面
			if(window.webglCom){
				window.webglCom.showWebgl = true;//显示webgl
				mapVue.$forceUpdate()
			}
		}else{
			if(window.webglCom){
				window.webglCom.showWebgl = false;//隐藏webgl
				mapVue.$forceUpdate()
			}
		}
		
	},
	//页面销毁时，注销监听程序|返回上一页，去往下一页等
	destroyed(){
		window.removeEventListener('beforeunload', this.pvCloseHandle);
		window.removeEventListener('visibilitychange', this.visibilitychange);
	},
	// beforeDestroy() {
	// 	console.warn("---beforeDestroy---")
	// 	this.pvCloseHandle()
	// },
	// /**
	//  * 生命周期函数--监听页面隐藏
	//  */
	// onHide: function() {
	// 	console.warn("---onhide---")
	// 	this.pvCloseHandle()
	// },
	// beforeUpdate() {
	// 	console.warn("beforeUpdate");
	// 	// 移除visibilitychange事件监听器
	// 	window.removeEventListener('visibilitychange', this.visibilitychange);
	// },
	beforeRouteLeave(to, from, next) {
		console.warn("router:beforeRouteLeave:",from.name);
		// 在离开当前路由前执行的方法
		// 例如保存表单数据、清理定时器等操作
		this.pvCloseHandle();
		if(window.webglCom && window.webglCom.stopRender && typeof(window.webglCom.stopRender)==='function'){
			window.webglCom.stopRender();
			if(from.name=="webgl_rxdz_roam"){//离开具体的空间详情页面，则需要先注销限制条件
				window.webglCom.spaceLeave();
			}
			if(to.name=="webgl_rxdz" || to.name=="webgl_rxdz_roam" || to.name=="webgl_rxdz_look"
			 || to.name=="webgl_rxdz_test" || to.name=="webgl_rxdz_test_roam" || to.name=="webgl_rxdz_test_look"){//去往其他页面
				webglCom.showWebgl = true;//显示webgl
				mapVue.$forceUpdate()
			}else{
				webglCom.showWebgl = false;//隐藏webgl
				mapVue.$forceUpdate()
			}
		}
		
		window.removeEventListener('beforeunload', this.pvCloseHandle);//注销监听刷新事件
		window.removeEventListener('visibilitychange', this.visibilitychange);
		next();
	},
	beforeRouteEnter(to, from, next) {
		console.warn("router:beforeRouteEnter:",to.name,to);
		if(window.webglCom && window.webglCom.reset && typeof(window.webglCom.reset)==='function'){
			if(to.name=="webgl_rxdz" && from.name=="webgl_rxdz_roam"){//返回
				window.webglCom.reset()
			}
			if(to.name=="webgl_rxdz_roam" && from.name=="webgl_rxdz_customize"){//从作品页返回空间详情页面
				window.webglCom.spaceEnter()
				window.webglCom.reset()
			}
			if(to.name=="webgl_rxdz" || to.name=="webgl_rxdz_roam" || to.name=="webgl_rxdz_look"
			 || to.name=="webgl_rxdz_test" || to.name=="webgl_rxdz_test_roam" || to.name=="webgl_rxdz_test_look"){//去往其他页面
				webglCom.showWebgl = true;//显示webgl
				mapVue.$forceUpdate()
			}else{
				webglCom.showWebgl = false;//隐藏webgl
				mapVue.$forceUpdate()
			}
		}
		
		next();
	},
	activated(){
		console.warn("activated:",this.pvId); 
		if(this.pvId && this.$route.meta.keepAlive){
			window.removeEventListener('beforeunload', this.pvCloseHandle);
			window.removeEventListener('visibilitychange', this.visibilitychange);
			window.currentPage = this;
			if(window.webglCom && window.webglCom.starRender && typeof(window.webglCom.starRender)==='function'){
				window.webglCom.starRender()
			}
			let param = {
				type: 'PV',
				pvId: this.pvId,
				locusBehaviorName: this.locusBehaviorName,
				pvCurPageName: this.pvCurPageName,
			};
			util.trackRequest(param);//发送统一PV埋点
			window.addEventListener('beforeunload', this.pvCloseHandle);
			window.addEventListener('visibilitychange', this.visibilitychange);
		}
	},
	methods: {
		visibilitychange(){
			console.warn("visibilitychange");
			if (document.visibilityState !== 'visible') { // 离开页面
				if(window.webglCom && window.webglCom.stopRender && typeof(window.webglCom.stopRender)==='function'){
					window.webglCom.stopRender()
				}
				this.pvCloseHandle()
			} else { // 进入页面
				if(window.webglCom && window.webglCom.starRender && typeof(window.webglCom.starRender)==='function'){
					window.webglCom.starRender()
				}
				this.pvShowHandle()
			}
		},
		pvShowHandle(){
			if(this.pvId){
				let param = {
					type: 'PV',
					pvId: this.pvId,
					locusBehaviorName: this.locusBehaviorName,
					pvCurPageName: this.pvCurPageName,
				};
				util.trackRequest(param);//发送统一PV埋点
			}
		},
		pvCloseHandle(){
			if(this.pvId){
				let param = {
					type: 'PV',
					pvId: this.pvId + '_close',
					pvCurPageName: this.pvCurPageName,
					locusBehaviorName: this.locusBehaviorName,
				};
				util.trackRequest(param);
			}
		},
	}
}
